#include <bits/stdc++.h>
using namespace std;
long long N,k,t,a[200022],res,perm[10],poc,znak;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> t;
    cin >> N >> k;
    for(int i=1;i<=N;i++){
        cin >> a[i];
    }
    sort(a+1,a+N+1);
    ///subset ako su sbi isti


    if(N<=8){
        for(int i=1;i<=N;i++){
            perm[i]=i;
        }
        znak=0;
        do{
            poc=0;
            for(int i=1;i<=N;i++){
                if(poc<=a[perm[i]])
                    poc++;
                else
                    poc--;
            }
            if(poc==k){
                znak=1;
                cout << "DA\n";
                if(t){
                    for(int i=1;i<=N;i++){
                    cout << perm[i] << " ";
                }
                    cout << endl;
                }
                return 0;

            }



        }while(next_permutation(perm+1,perm+N+1));

        cout << "NE\n";

    }


    else if(a[1]==a[N]){
        if(a[1]>=0){
            if(a[1]>N){
                res=N;
            }
            else{
                res=a[1]+(N-a[1])%2;
            }
            if(res==k){
                cout << "DA\n";
                if(t==1){
                    for(int i=1;i<=N;i++)
                        cout << a[i]<< " ";
                    cout << endl;
                }
            }
            else{
                cout << "NE\n";
            }
        }
        else{
            if(abs(a[1])>N){
                res=N*(-1);
            }
            else{
                res=a[1]+(N-abs(a[1]))%2;
            }
            if(res==k){
                cout << "DA\n";
                if(t==1){
                    for(int i=1;i<=N;i++)
                        cout << a[i]<< " ";
                    cout << endl;
                }
            }
            else{
                cout << "NE\n";
            }
        }


    }
    ///subset gde ne prelazi k

    else{
        if(t){
            cout <<"NE\n";
        }


    }


    return 0;
}